import { canPayBuildingCost, enqueueBuilding, getBuildingUpgradeCost } from "../utils";
import type { VillageState } from "../village";


export default function upgradeBuilding(V: VillageState, buildingId: number) {
    const building = V.buildings.find(b => b.id === buildingId);
    if (!building) {
        return false;
    }

    if (!canPayBuildingCost(V, building)) {
        return false;
    }

    const cost = getBuildingUpgradeCost(V, building);

    V.resources.wood -= cost.wood;
    V.resources.stone -= cost.stone;
    V.resources.iron -= cost.iron;
    V.resources.food -= cost.food;
    enqueueBuilding(V, building);

    return true;
}
